#include "defs.h"
#include <stdio.h>

/* Definition of global variables */
population popcurr, popnew;
int gaMode; // GA mode: 1. standard (SGA), 2. standard random immigrants (RIGA1) 
            //  3. random immigrants replace the worst individuals (RIGA2)
            //  4. elitism-based GA (EIGA), 5. elitism and dualism-based GA (EDIGA)
            //  6. hybrid immigrants GA (HIGA)

int functNo = 1;  // Function: 1-DUF(25,4,1), 2-DUF(25,4,3), 3-DUF(25,4,4), 
                  //   4-DUF(25,4,deceptive), 25 copies of 4-bit deceptive problems
                  //   5-Knapsack Problem

// Parameters of simulation
int changeMode = 1; // how environment changes, cyclical or not
                    //   1: cyclic, 2: cyclic with noise, 3: random
double changeDegree = 0.5; // ratio of loci changed in dynamic environment, i.e., rho
int changeSpeed = 10;      // period of environment changing in generations
int totalChanges = 50;     // total number of environment changes in a run
bool changeDetected;       // whether the enviroment change has been detected
int *xorMask;              // mask for XORing environment
bool bRandRatio = false;   // whether changeDegree is random (false by default)
int **baseXORMasks;        // base xor masks for cyclic environment
int totalBaseStates;
double pBaseMut = 0.05;    // prob. of mutating each element of a base XOR mask 
long int currGenNo;        // generation
int totalRuns = 30;	   // number of runs of a GA

int maxgen;                // max number of generations 
int flag_no_crossover= 0;  // disable crossover if set to 1
int flag_no_mutation = 0;  // disable mutation if set to 1
double *log_mean_fitness;
double *log_best_fitness;
double *log_mean_diversity; 
bool bRecordDiversity = false;

// RIs
int num_immigrants = 3;	    // RIs: number of individuals replaced each generation
int num_rand_immigrants =0; // number of random immigrants
int num_elite_immigrants=0; // number of elitism-based immigrants
int num_dual_immigrants =0; // number of dualism-based immigrants
int delta_immigrants = 2;   // change of immigrants number
int min_immigrants = 4;     // minimum number of immigrants for each scheme
double ratio_immigrants;    // ratio of immigrants to pop size
double pImmigMut = 0.01;    // prob. of mutating the elite from last generation
                            // or its dual (1 - pImmigMut)

int flag_elitism;
individual individual_best;
individual individual_best_2;
individual elite_prev_pop;      // elite from previous population

// Parameters of GAs
double pCrossover = 0.7;	// probability of crossover
double pMutation = 0.01;	// probability of mutation
int popsize = 100;		// population size
int lchrom = 100;               // length of chromosome
int elitism = 1;	        // 1: elitism; 0: no elitism
double tournament_param = 1.0;  // probability that the fitter individual
                                // wins in the tournament selection

// Parameters for Knapsack problem
int *weight;
int *profit;
int CAPACITY, TOTALWEIGHT;
double capFactor = 0.5;

